﻿using UnityEngine;
using System.Collections;

public class BackgroundMusic : MonoBehaviour //http://answers.unity3d.com/questions/11314/audio-or-music-to-continue-playing-between-scene-c.html
{
	void Start () 
	{
		DontDestroyOnLoad(gameObject);
	}

	void Update () 
	{
		_mCurrentTime = this.gameObject.GetComponent<AudioSource>().time;
	}

	void OnLevelWasLoaded()
	{
		this.gameObject.GetComponent<AudioSource>().time = _mCurrentTime;
	}

	void Awake() 
	{
		if (_msSingleton != null && _msSingleton != this) 
		{
			Destroy(this.gameObject);
			return;
		}
		else 
		{
			_msSingleton = this;
		}

		DontDestroyOnLoad(this.gameObject);
	}

	private float _mCurrentTime;
	private static BackgroundMusic _msSingleton;
}
