﻿using UnityEngine;
using System.Collections;

/* Keeps the camera locked on the player within definable boundaries */

// Created by Alex Smith, January 24th, 2014
// Edited by Alex Smith, January 25th, 2014

public class CameraFollow : MonoBehaviour {

	public Vector3 trackerRange;
	public Vector3 trackerOffset;
	public Vector3 panSpeed;
	public bool smooth = true;
	public float movementRatio;

	public GameObject target;

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update ()
	{
		Vector3 newPosition = transform.position;
		if(target.transform.position.x < (transform.position.x - trackerRange.x) + trackerOffset.x)
		{
			if(smooth)
			{

			}
			else
			{
				newPosition.x = target.transform.position.x + trackerRange.x - trackerOffset.x;
			}
		}
		if(target.transform.position.x > (transform.position.x + trackerRange.x) + trackerOffset.x)
		{
			if(smooth)
			{
				
			}
			else
			{
				newPosition.x = target.transform.position.x - trackerRange.x - trackerOffset.x;
			}
		}

		if(target.transform.position.y < (transform.position.y - trackerRange.y) + trackerOffset.y)
		{
			if(smooth)
			{
				
			}
			else
			{
				newPosition.y = target.transform.position.y + trackerRange.y - trackerOffset.y;
			}
		}
		if(target.transform.position.y > (transform.position.y + trackerRange.y) + trackerOffset.y)
		{
			if(smooth)
			{
				
			}
			else
			{
				newPosition.y = target.transform.position.y - trackerRange.y - trackerOffset.y;
			}
		}

		transform.position = newPosition;
	}
}
