﻿using UnityEngine;
using System.Collections;

public class FootCollider : MonoBehaviour {

	private Vector3 positionOffset;

	// Use this for initialization
	void Start ()
	{
		// Will be used later to keep the player and the foot collider together
		positionOffset = transform.localPosition;
	}
	
	// Update is called once per frame
	void Update () {

		// This keeps the foot collider moving with the player
		transform.position = PlayerController.playerPosition + positionOffset;

	}

	void OnTriggerStay(Collider collision)
	{
		// If the foot collider hits something that isn't the player, it can jump again
		if(collision.gameObject.tag != "Player")
		{
			PlayerController.onGround = true;
		}
	}

	void OnTriggerExit(Collider collision)
	{
		if(collision.gameObject.tag != "Player")
		{
			PlayerController.onGround = false;
		}
	}
}
