﻿using UnityEngine;
using System.Collections;

/* Controls the shadow/colour states of the game. NOTE, ATTACH THIS TO THE MAIN CAMERA. */

// Created by Gary Ng, January 24th, 2014
// Edited by Alex Smith, January 25th, 2014 (marked as (A.S.))

public class GameModeController : MonoBehaviour
{
	void Start() //Use this for initialization
	{
		msShadowMode = false;
		inShadowMode = false;
		//_mTransitionSpeed = 0.02f; //How fast we transition
		//_mTransitionTime = 0.0f;
		//_mTransitionActive = false;

		_mDestinationPosition[0] = new Vector3(0.0f, 1.0f, -10.0f); //Colour mode
		_mDestinationPosition[1] = new Vector3(0.0f, 1.6f, 15.0f); //Shadow mode


		//_mShadowPlatforms = Object.FindObjectsOfType<PlatformAttribute>();
		//toggleShadowPlatforms();
	}

	void Update() //Update is called once per frame
	{
		msTransitionSpeed = _mTransitionSpeed;

		if(isActive)
		{
			if (Input.GetKeyDown(KeyCode.Z)) //Z is the current toggle for switching shadow
			{
				//++msShadowMode; //Increment it. Remember, even means colour, odd means shadow
				msShadowMode = !msShadowMode;	// A.S.
				//_mTransitionActive = true;
				//_mTransitionTime = 0.0f;
				
				//toggleShadowPlatforms();
			}
			
			// A.A. Have the existing transitions hooked up to the modified msShadowMode variable (same effect, different implementation)
			if(msShadowMode)
			{
				this.transform.position = Vector3.MoveTowards(this.transform.position, mShadowNode.transform.position, Time.deltaTime*_mTransitionSpeed);
				if(Vector3.Distance(this.transform.position, mShadowNode.transform.position) < mThresholdCheck)
				{
					inShadowMode = true;
					//_mTransitionActive = false;
				}
			}
			else
			{
				inShadowMode = false;
				this.transform.position = Vector3.MoveTowards(this.transform.position, mColorNode.transform.position, Time.deltaTime*_mTransitionSpeed);
				if(Vector3.Distance(this.transform.position, mColorNode.transform.position) < mThresholdCheck)
				{
					//_mTransitionActive = false;
				}
			}
		}

		//_mTransitionTime += _mTransitionSpeed; //Increment time
		// A.S. swapped _mTransitionSpeed with Time.deltaTime due to the existing variable in Unity's engine
		//this.transform.position = new Vector3(this.transform.position.x, Mathf.Lerp(this.transform.position.y, _mDestinationPosition[System.Convert.ToInt32(msShadowMode)].y, Time.deltaTime), Mathf.Lerp(this.transform.position.z, _mDestinationPosition[System.Convert.ToInt32(msShadowMode)].z, Time.deltaTime)); //Lerp with ease in and out
		//this.transform.position = Vector3.Lerp(this.transform.position, _mDestinationPosition[System.Convert.ToInt32(msShadowMode)], Time.deltaTime*_mTransitionSpeed);
	}
	
//	void toggleShadowPlatforms() //Toggles the activeness of the shadow platforms based on the state of the game
//	{
//		for (uint i = 0; i < _mShadowPlatforms.Length; ++i)
//		{
//			if (msShadowMode)
//			{
//				_mShadowPlatforms[i].gameObject.SetActive(true);
//			}
//			else
//			{
//				_mShadowPlatforms[i].gameObject.SetActive(false);
//			}
//		}
//	}

	public bool isActive = true;
	public static bool inShadowMode;
	private bool msShadowMode; //If this is even it means we're in colour mode. Odd means it's in shadow mode
	public float _mTransitionSpeed; //The speed at which the camera transitions	// A.S. made public for inspector editing
	public static float msTransitionSpeed;
	//private bool _mTransitionActive; // Defines when the camera is transitioning between modes
	public float mThresholdCheck;	// A distance check for setting the public mode boolean
	//private float _mTransitionTime; //The counter used for lerp

	private Vector3[] _mDestinationPosition = new Vector3[2]; //0 is colour mode, 1 is shadow mode. Note that X doesn't matter
	public GameObject mColorNode;
	public GameObject mShadowNode;
	//private PlatformAttribute[] _mShadowPlatforms; //The platforms that need to be enabled in shadow mode and disabled in colour mode
}
