﻿using UnityEngine;
using System.Collections;

public class MainMenuButton : MonoBehaviour 
{
	// Use this for initialization
	void Start() 
	{
		_mCamera = GameObject.Find("Main Camera");
		_mShadowPos = new Vector3(0, 1, 15);
		_mTransition = false;
		_mTransitionTime = 0.0f;
	}
	
	// Update is called once per frame
	void Update() 
	{
		if (_mTransition == true)
		{
			_mTransitionTime += GameModeController.msTransitionSpeed;
			_mCamera.transform.position = Vector3.MoveTowards(_mCamera.transform.position, _mShadowPos, Time.deltaTime*GameModeController.msTransitionSpeed);
		}
	}

	void OnMouseOver()
	{
		if (Input.GetMouseButtonDown(0))
		{
			_mTransition = true;
			_mCamera.GetComponent<SceneTransition>().sceneToLoad = mSceneLink;
			_mCamera.GetComponent<SceneTransition>().win = true;
		}
	}

	public int mSceneLink; //The scene to go to when this button is pressed

	private GameObject _mCamera;
	private Vector3 _mShadowPos;
	private bool _mTransition;
	
	private float _mTransitionTime; //The counter used for lerp
}
