﻿using UnityEngine;
using System.Collections;

public class SideCollider : MonoBehaviour {

	private Vector3 positionOffset;
	public bool isRightSide = false;
	
	// Use this for initialization
	void Start ()
	{
		// Will be used later to keep the player and the foot collider together
		positionOffset = transform.localPosition;
	}
	
	// Update is called once per frame
	void Update () {
		
		// This keeps the foot collider moving with the player
		transform.position = PlayerController.playerPosition + positionOffset;
		
	}
	
	void OnTriggerEnter(Collider collision)
	{
		// If the foot collider hits something that isn't the player, it can jump again
		if(collision.gameObject.tag != "Player" && collision.gameObject.tag != "CRATE")
		{
			if(isRightSide)
				PlayerController.onWallRight = true;
			else
				PlayerController.onWallLeft = true;
		}
	}
	
	void OnTriggerExit(Collider collision)
	{
		if(collision.gameObject.tag != "Player")
		{
			if(isRightSide)
				PlayerController.onWallRight = false;
			else
				PlayerController.onWallLeft = false;
		}
	}
}
